// @generated by protobuf-ts 2.9.4
// @generated from protobuf file "game_stats.proto" (package "gamestats", syntax proto3)
// tslint:disable
import type { RpcTransport } from "@protobuf-ts/runtime-rpc";
import type { ServiceInfo } from "@protobuf-ts/runtime-rpc";
import { GameStats } from "./game_stats";
import type { ServerStreamingCall } from "@protobuf-ts/runtime-rpc";
import type { CombinedGameStats } from "./game_stats";
import type { TeamStats } from "./game_stats";
import { stackIntercept } from "@protobuf-ts/runtime-rpc";
import type { EmptyRequest } from "./game_stats";
import type { GameMetadata } from "./game_stats";
import type { UnaryCall } from "@protobuf-ts/runtime-rpc";
import type { RpcOptions } from "@protobuf-ts/runtime-rpc";
/**
 * @generated from protobuf service gamestats.GameStats
 */
export interface IGameStatsClient {
    /**
     * @generated from protobuf rpc: UpdateGameMetadata(gamestats.GameMetadata) returns (gamestats.EmptyRequest);
     */
    updateGameMetadata(input: GameMetadata, options?: RpcOptions): UnaryCall<GameMetadata, EmptyRequest>;
    /**
     * @generated from protobuf rpc: UpdateTeamStats(gamestats.TeamStats) returns (gamestats.EmptyRequest);
     */
    updateTeamStats(input: TeamStats, options?: RpcOptions): UnaryCall<TeamStats, EmptyRequest>;
    /**
     * @generated from protobuf rpc: UpdateCombinedGameStats(gamestats.CombinedGameStats) returns (gamestats.EmptyRequest);
     */
    updateCombinedGameStats(input: CombinedGameStats, options?: RpcOptions): UnaryCall<CombinedGameStats, EmptyRequest>;
    /**
     * @generated from protobuf rpc: GetGameStats(gamestats.EmptyRequest) returns (gamestats.CombinedGameStats);
     */
    getGameStats(input: EmptyRequest, options?: RpcOptions): UnaryCall<EmptyRequest, CombinedGameStats>;
    /**
     * @generated from protobuf rpc: MonitorGameStats(gamestats.EmptyRequest) returns (stream gamestats.CombinedGameStats);
     */
    monitorGameStats(input: EmptyRequest, options?: RpcOptions): ServerStreamingCall<EmptyRequest, CombinedGameStats>;
}
/**
 * @generated from protobuf service gamestats.GameStats
 */
export class GameStatsClient implements IGameStatsClient, ServiceInfo {
    typeName = GameStats.typeName;
    methods = GameStats.methods;
    options = GameStats.options;
    constructor(private readonly _transport: RpcTransport) {
    }
    /**
     * @generated from protobuf rpc: UpdateGameMetadata(gamestats.GameMetadata) returns (gamestats.EmptyRequest);
     */
    updateGameMetadata(input: GameMetadata, options?: RpcOptions): UnaryCall<GameMetadata, EmptyRequest> {
        const method = this.methods[0], opt = this._transport.mergeOptions(options);
        return stackIntercept<GameMetadata, EmptyRequest>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: UpdateTeamStats(gamestats.TeamStats) returns (gamestats.EmptyRequest);
     */
    updateTeamStats(input: TeamStats, options?: RpcOptions): UnaryCall<TeamStats, EmptyRequest> {
        const method = this.methods[1], opt = this._transport.mergeOptions(options);
        return stackIntercept<TeamStats, EmptyRequest>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: UpdateCombinedGameStats(gamestats.CombinedGameStats) returns (gamestats.EmptyRequest);
     */
    updateCombinedGameStats(input: CombinedGameStats, options?: RpcOptions): UnaryCall<CombinedGameStats, EmptyRequest> {
        const method = this.methods[2], opt = this._transport.mergeOptions(options);
        return stackIntercept<CombinedGameStats, EmptyRequest>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: GetGameStats(gamestats.EmptyRequest) returns (gamestats.CombinedGameStats);
     */
    getGameStats(input: EmptyRequest, options?: RpcOptions): UnaryCall<EmptyRequest, CombinedGameStats> {
        const method = this.methods[3], opt = this._transport.mergeOptions(options);
        return stackIntercept<EmptyRequest, CombinedGameStats>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: MonitorGameStats(gamestats.EmptyRequest) returns (stream gamestats.CombinedGameStats);
     */
    monitorGameStats(input: EmptyRequest, options?: RpcOptions): ServerStreamingCall<EmptyRequest, CombinedGameStats> {
        const method = this.methods[4], opt = this._transport.mergeOptions(options);
        return stackIntercept<EmptyRequest, CombinedGameStats>("serverStreaming", this._transport, method, opt, input);
    }
}
